(function (Misago) {
  'use strict';

  Misago.addService('page-title', function(_) {
    _.title = {
      forum_name: _.settings.forum_name,

      set: function(title) {
        if (title) {
          this._set_complex(title);
        } else {
          document.title = this.forum_name;
        }
      },

      _set_complex: function(title) {
        if (typeof title === 'string') {
          title = {title: title};
        }

        var completeTitle = title.title;

        if (typeof title.page !== 'undefined' && title.page > 1) {
          completeTitle += ' (' + interpolate(gettext('page %(page)s'), { page:title.page }, true) + ')';
        }

        if (typeof title.parent !== 'undefined') {
          completeTitle += ' | ' + title.parent;
        }

        document.title = completeTitle + ' | ' + this.forum_name;
      }
    };
  });
}(Misago.prototype));
